<template>
  <v-dialog v-model="display" :width="dialogWidth">
    <template #activator="{ props }">
      <v-text-field v-bind="{ ...textFieldProps, ...props, ...$attrs }" :disabled="disabled" :dense="dense"
        :loading="loading" :label="label" :model-value="formattedDatetime" :error-messages="errorMessages"
        :class="{ 'required': required }" @blur="blur" readonly variant="outlined">
        <template #loader>
          <slot name="progress">
            <v-progress-linear color="primary" indeterminate absolute height="2"></v-progress-linear>
          </slot>
        </template>
      </v-text-field>
    </template>

    <v-card>
      <v-card-text class="px-0 py-0">
        <v-tabs fixed-tabs v-model="activeTab">
          <v-tab value="calendar">
            <slot name="dateIcon">
              <v-icon>event</v-icon>
            </slot>
          </v-tab>
          <v-tab value="timer" :disabled="isDateSelected">
            <slot name="timeIcon">
              <v-icon>access_time</v-icon>
            </slot>
          </v-tab>
        </v-tabs>
        <v-tabs-window v-model="activeTab">
          <v-tabs-window-item value="calendar">
            <v-date-picker v-model="proxyDate" v-bind="datePickerProps" @update:model-value="showTimePicker"
              full-width></v-date-picker>
          </v-tabs-window-item>
          <v-tabs-window-item value="timer">
            <v-time-picker ref="timer" class="v-time-picker-custom" v-model="time" v-bind="timePickerProps"
              full-width></v-time-picker>
          </v-tabs-window-item>
        </v-tabs-window>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <slot name="actions">
          <v-btn color="grey lighten-1" text @click.native="clearHandler">{{ clearText }}</v-btn>
          <v-btn color="green darken-1" text @click="okHandler">{{ okText }}</v-btn>
        </slot>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { format, parse } from 'date-fns'
import type { VDatePicker } from 'vuetify/components/VDatePicker'
import type { VTextField } from 'vuetify/components/VTextField'
import type { VTimePicker } from 'vuetify/labs/VTimePicker'

defineOptions({
  name: 'v-datetime-picker',
  inheritAttrs: false,
})

const DEFAULT_DATE = ''
const DEFAULT_TIME = '00:00:00'
const DEFAULT_DATE_FORMAT = 'yyyy-MM-dd'
const DEFAULT_TIME_FORMAT = 'HH:mm:ss'
const DEFAULT_DIALOG_WIDTH = 340
const DEFAULT_CLEAR_TEXT = 'ANNULER'
const DEFAULT_OK_TEXT = 'OK'

const datetime = defineModel<Date>();

const props = withDefaults(defineProps<{
  disabled?: boolean,
  loading?: boolean,
  label?: string,
  dense?: boolean,
  dialogWidth?: number,
  dateFormat?: string,
  timeFormat?: string,
  clearText?: string,
  okText?: string,
  textFieldProps?: Partial<VTextField['$props']>,
  datePickerProps?: VDatePicker,
  timePickerProps?: Partial<VTimePicker['$props']>,
  errorMessages?: string[],
  required?: boolean
}>(), {
  label: '',
  dialogWidth: DEFAULT_DIALOG_WIDTH,
  dateFormat: DEFAULT_DATE_FORMAT,
  timeFormat: 'HH:mm',
  clearText: DEFAULT_CLEAR_TEXT,
  okText: DEFAULT_OK_TEXT,
});

const emit = defineEmits<{
  input: [Date | undefined],
  change: [],
  blur: []
}>()

const timer = ref();

const display = ref(false)
const activeTab = ref(0)
const date = ref<string | null>(DEFAULT_DATE)
const time = ref(DEFAULT_TIME)

function init() {
  if (!datetime.value) {
    date.value = DEFAULT_DATE;
    time.value = DEFAULT_TIME;
  }

  let initDateTime
  if (datetime.value instanceof Date) {
    initDateTime = datetime.value
  } else if (typeof datetime.value === 'string') {
    // see https://stackoverflow.com/a/9436948
    initDateTime = parse(datetime.value, dateTimeFormat.value, new Date())
  }

  if (initDateTime) {
    date.value = format(initDateTime, props.dateFormat)
    time.value = format(initDateTime, props.timeFormat)
  }
}

const dateTimeFormat = computed(() => props.dateFormat + ' ' + props.timeFormat);
const defaultDateTimeFormat = DEFAULT_DATE_FORMAT + ' ' + DEFAULT_TIME_FORMAT;
const formattedDatetime = computed(() => selectedDatetime.value ? format(selectedDatetime.value, dateTimeFormat.value) : '');
const selectedDatetime = computed<Date | undefined>(() => {
  if (date.value && time.value) {
    let datetimeString = date.value + ' ' + time.value
    if (time.value.length === 5) {
      datetimeString += ':00'
    }
    return parse(datetimeString, defaultDateTimeFormat, new Date())
  } else {
    return undefined
  }
});
const proxyDate = computed({
  get: () => date.value ? new Date(date.value) : new Date(),
  set: (value) => date.value = format(value, props.dateFormat)
})

const isDateSelected = computed(() => !date);

function okHandler() {
  resetPicker()
  datetime.value = selectedDatetime.value
  emit('change')
}
function clearHandler() {
  resetPicker()
  date.value = DEFAULT_DATE
  time.value = DEFAULT_TIME
  datetime.value = undefined
  emit('input', undefined)
  emit('change')
}
function resetPicker() {
  display.value = false
  activeTab.value = 0
  if (timer.value) {
    timer.value.selectingHour = true
  }
}
function showTimePicker() {
  activeTab.value = 1
}
function blur() {
  emit('blur');
}

onMounted(() => {
  init()
});

watch(datetime, () => init())
</script>
